﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Services.Hive.DataAccess;

namespace HeuristicLab.Services.Hive {

  public class ServiceLocator {
    private static CreateDataContext<HiveDataContext> contextCreator = new CreateDataContext<HiveDataContext>(ContextFactory<HiveDataContext>.CreateHiveContext);

    private static ServiceLocator instance;
    public static ServiceLocator Instance {
      get {
        if (instance == null) instance = new ServiceLocator();
        return instance;
      }
    }

    private IHiveDao hiveDao;
    public IHiveDao HiveDao {
      get {
        if (hiveDao == null) hiveDao = new HiveDao(ContextFactory);
        return hiveDao;
      }
    }

    private IContextFactory<HiveDataContext> contextFactory;
    public IContextFactory<HiveDataContext> ContextFactory {
      get {
        if(contextFactory == null) contextFactory = new ContextFactory<HiveDataContext>(contextCreator);
        return contextFactory;
      }
    }

    private IAuthorizationManager authorizationManager;
    public IAuthorizationManager AuthorizationManager {
      get {
        if (authorizationManager == null) authorizationManager = new AuthorizationManager();
        return authorizationManager;
      }
    }
  }
}
